import java.util.*;
import java.io.*;

class Test {
	public static <T> void findDoubles(List<T> data){
		Map<T, Integer> m = new HashMap<>();
		for(int i=0; i<data.size(); i++)
			if(m.containsKey(data.get(i))){
				System.out.println("Element "+i+ " is the same as Element " + m.get(data.get(i)));
			}else{
				m.put(data.get(i),i);
			}
	}
	public static <T> void findDoublesSlow(List<T> data){
		for(int i=0; i<data.size(); i++)
			for(int j=i+1; j<data.size(); j++)
				if(data.get(i).equals(data.get(j)))
					System.out.println("Element "+i+ " is the same as Element " +j);
	}
	public static void main(String [] args){
		//Test case 1: Find identical images
		ArrayList<Image> images = new ArrayList<>();
		for(int i=0; i<args.length; i++)
			images.add(new Image(args[i]));
		findDoublesSlow(images);
		findDoubles(images);
		//Test case 2: Read file, find identical integers
	/*	File file = new File(args[0]);
		Scanner sc = null;
		ArrayList<Integer> data = new ArrayList<>();
		try{
			sc = new Scanner(file);
			while(sc.hasNextInt())
				data.add(sc.nextInt());
		}catch(IOException e){
			System.out.println("File I/O error!");
			e.printStackTrace();
		}finally{
			if(sc!=null) sc.close();
		}
//		System.out.println("Silly algorithm!");
//		findDoublesSlow(data);
//		System.out.println("Silly algorithm done!");
		System.out.println("Good algorithm!");
		findDoubles(data);
		System.out.println("Good algorithm done!");*/

	}
}
